from bzrlib import tests


import icommon


class FindEarliestMergeTests(tests.TestCaseWithTransport):

    def test_tip_revision(self):
        t = self.make_branch_and_tree(".")
        revid = t.commit("one")
        self.assertEquals(revid,
                icommon.find_earliest_merge(t.branch, revid))

    def test_a_parent(self):
        t = self.make_branch_and_tree(".")
        revid = t.commit("one")
        t.commit("two")
        t.commit("three")
        self.assertEquals(revid,
                icommon.find_earliest_merge(t.branch, revid))

    def test_merged(self):
        t = self.make_branch_and_tree(".")
        t.commit("one")
        t2 = t.bzrdir.sprout("merged").open_workingtree()
        merged_revid = t2.commit("one and a half")
        t.merge_from_branch(t2.branch)
        revid = t.commit("two")
        t.commit("three")
        self.assertEquals(revid,
                icommon.find_earliest_merge(t.branch, merged_revid))


