from bzrlib import tests


import icommon


class ImportListTests(tests.TestCase):

    def make_simple(self):
        self.pkg1 = icommon.PackageToImport("pkg", "0.1-1", "ubuntu",
                "jaunty", "Release")
        self.pkg2 = icommon.PackageToImport("pkg", "1.0-1", "ubuntu",
                "karmic", "Release")
        list = icommon.ImportList()
        list.add_if_needed(self.pkg1)
        list.add_if_needed(self.pkg2)
        return list

    def test_str(self):
        list = self.make_simple()
        self.assertEqual("[PackageToImport(pkg, 0.1-1, ubuntu, "
                "jaunty, Release, ), PackageToImport(pkg, 1.0-1, "
                "ubuntu, karmic, Release, )]", str(list))

    def test_sort(self):
        list = self.make_simple()
        # make_simple's list is already sorted, reverse it to prove that
        # sorting will restore the original order:
        list.plist.reverse()
        self.assertEqual([self.pkg2, self.pkg1], list.plist)
        list.sort()
        self.assertEqual([self.pkg1, self.pkg2], list.plist)

    def test_add_if_needed(self):
        list = self.make_simple()
        self.assertEqual([self.pkg1, self.pkg2], list.plist)
        list.add_if_needed(self.pkg1)
        self.assertEqual([self.pkg1, self.pkg2], list.plist)


